var Cc = Components.classes;
var Ci = Components.interfaces;
var atomService = Cc["@mozilla.org/atom-service;1"].getService(Ci.nsIAtomService);

function onStart() {
  treeView.updateRowCount();
  var mtree = document.getElementById("threadTree");
  mtree.treeBoxObject.view = treeView;
  mtree.treeBoxObject.cellCanvas = treeCellCanvas;

  //https://developer.mozilla.org/en-US/docs/Web/Events
  var treeBody = document.getElementById("threadTreeBody");
  treeBody.addEventListener('click', treeCellCanvas, true);
  treeBody.addEventListener('dblclick', treeCellCanvas, true);
  treeBody.addEventListener('mousedown', treeCellCanvas, true);
  treeBody.addEventListener('mouseenter', treeCellCanvas, true);
  treeBody.addEventListener('mouseleave', treeCellCanvas, true);
  treeBody.addEventListener('mousemove', treeCellCanvas, true);
  treeBody.addEventListener('mouseover', treeCellCanvas, true);
  treeBody.addEventListener('mouseout', treeCellCanvas, true);
  treeBody.addEventListener('mouseup', treeCellCanvas, false);
}

var cellRenderCanvas;
var treeCellCanvas = {
  // nsISupports
  QueryInterface: function(aIID) {
    if (aIID.equals(Ci.nsITreeCellCanvas) ||
        aIID.equals(Ci.nsIDOMEvent) ||
        aIID.equals(Ci.nsISupports) ||
        aIID.equals(Ci.nsISupportsWeakReference))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },
  handleEvent: function(event) {
    var x = event;
  },
  //AString render(in long row, in nsITreeColumn col, in long x, in long y, in long width, in long height, in nsIMutableArray props);
  render: function(view, row, col, x, y, width, height, props) {
    if (!cellRenderCanvas)
    {
      cellRenderCanvas = window.document.createElementNS("http://www.w3.org/1999/xhtml", "canvas");
    }

    x = x / 60;
    y = y / 60;
    width = width / 60;
    height = height / 60;
    cellRenderCanvas.width  = width;
    cellRenderCanvas.height = height;
    var ctx = cellRenderCanvas.getContext("2d");
    ctx.clearRect(0, 0, cellRenderCanvas.width, cellRenderCanvas.height);
    ctx.rect(0, 0, cellRenderCanvas.width, cellRenderCanvas.height);
    ctx.fillStyle="yellow";
    ctx.fill();

    ctx.beginPath();
    var bubbleTextStyle = "bold 11px Segoe UI";
    ctx.font = bubbleTextStyle;
    ctx.fillStyle="black";
    ctx.fillText("Row number: " + row.toString() + "!",0, 11);
    ctx.fillText("Hello, the world!",0, 22);

    ctx.beginPath();
    ctx.arc(50, 50, row % 10 + 10, 0, 2 * 3.14, false);
    ctx.fillStyle = 'green';
    ctx.fill();
    ctx.lineWidth = 5;
    ctx.strokeStyle = '#003300';
    ctx.stroke();
    return cellRenderCanvas.toDataURL("image/png");
  }
}

var gIdx=[
  {
    isRead: true,
    title: 'Hello, Gmail',
    hasAttachment: true,
    date: '2014-08-15 17:10',
    description: 'Comes from gmail.'
  }
  ,
  {
    isRead: true,
    title: 'Hello, Gmail',
    hasAttachment: true,
    date: '2014-08-15 17:10',
    description: 'Comes from gmail.'
  }
];

var treeView = {
  _rowCount: 0,
  updateRowCount: function() {
    this._rowCount = 1000000;
  },

  // nsISupports
  QueryInterface: function(aIID) {
    if (aIID.equals(Ci.nsITreeView) ||
        //aIID.equals(Ci.nsIMultilineTreeView) ||
        aIID.equals(Ci.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },

  // nsITreeView
  treeBox: null,
  selection: null,

  get rowCount()                     { return this._rowCount },
  setTree: function(treeBox)         { this.treeBox = treeBox; },
  getCellText: function(idx, column) {
    var node;
    if (idx <= 1) {
      node = gIdx[idx];
    } else {
      node = gIdx[0];
    }
    if (column.id == "isRead")
      return node.isRead;
    if (column.id == "title")
      return node.title;
    if (column.id == "hasAttachment")
      return node.hasAttachment;
    if (column.id == "date")
      return node.date;
    if (column.id == "description")
      return node.description;
    if (column.id == "rich")
      return "";
    if (column.id == "text")
      return "text";
    if (column.id == "image")
      return "image";
  },
  isContainer: function(idx)         { return false; },
  isContainerOpen: function(idx)     { return false; },
  isContainerEmpty: function(idx)    { return true; },
  isSeparator: function(idx)         { return false; },
  isSorted: function()               { return true; },
  isEditable: function(idx, column)  { return false; },

  getParentIndex: function(idx) { return -1; },
  getLevel: function(idx) { return 0; },
  hasNextSibling: function(idx, after) { return false; },
  toggleOpenState: function(idx) {},

  getImageSrc: function(idx, column) {},
  getProgressMode : function(idx,column) {},
  getCellValue: function(idx, column) {},
  cycleHeader: function(col, elem) {},
  selectionChanged: function() {},
  cycleCell: function(idx, column) {},
  performAction: function(action) {},
  performActionOnCell: function(action, index, column) {},

  getRowProperties: function(idx) {
    return 'richrowtitle richrowsubheader richrowsubheader';
  },
  getCellProperties: function(idx, column) {
     if (idx < 1) {
      return 'unread junk'
     } else {
      return 'read junk'
    }
  },
  getColumnProperties: function(column, element) {},
};

window.addEventListener("load", onStart, true);
